//+------------------------------------------------------------------+
//|                                                      ezMM EA.mq4 |
//|                              Copyright  2009, MethodTraders.com |
//|                                     http://www.methodtraders.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MethodTraders.com"
#property link      "http://www.methodtraders.com"

bool IT;
extern int MagicNumber = 1245;
extern int TakeProfit1 = 50;
extern int TakeProfit2 = 100;
extern int FinalTakeProfit = 150;
extern double TakeProfit1Percent = 35;
extern double TakeProfit2Percent = 35;
extern double RiskPerTrade = 5.0;
extern int HardStop = 0;
extern int MAPeriod = 6;
extern int StopAbove = 35;
extern int StopBelow = 35;
extern int StopMin = 20;
extern int MoveStop = 35;
extern int TrailingStop = 35;
extern int TrailStopMAPeriod = 6;
extern int TimeStopHours = 0;
//------------FOR BACKTEST
/*
extern bool TradeBuy = true;
extern bool TradeSell = false;
*/
//------------
double BLots = 0;
double SLots = 0;
double BSL = 0;
double SSL = 0;
double FTP = 0;

int MyDigits;
double MyPoint;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {
//----
  if(Digits==5)MyDigits=4;
  else if(Digits==3)MyDigits=2;
  else MyDigits = Digits; 
  if (Point == 0.00001) MyPoint = 0.0001; //6 digits
  else if (Point == 0.001) MyPoint = 0.01; //3 digits (for Yen based pairs)
  else MyPoint = Point; //Normal
   IT = true;
   
   SLValue();
   DrawValues();
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("ezMM MagicNumber");
   ObjectDelete("ezMM BLots");
   ObjectDelete("ezMM SLots");
   ObjectDelete("ezMM BSL");
   ObjectDelete("ezMM SSL");
   ObjectDelete("ezMM FTP");
//----;
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   SLValue();
   DrawValues();
   if(MoveStop>0)subBreakEvenAfterPips(MagicNumber,MoveStop);
   if(TrailingStop>0)subTrailingStop(MoveStop, TrailingStop);
   if(TimeStopHours>0)TimeStopHours();
   subPartialTP();
   //----------------FOR BACKTEST
   /*
   if(subTotalTrade()<1)
   {
      if(TradeBuy)subOpenOrder(OP_BUY, BSL, FTP ,BLots);
      if(TradeSell)subOpenOrder(OP_SELL, SSL, FTP ,SLots);
   }
   */
//----
   return(0);
  }
//+------------------------------------------------------------------+
//-------------------MONEY MANAGEMENT
void subPartialTP()
{
   int
      cnt, 
      total = 0;
   int    decimalPlaces=0;
   if(MarketInfo(Symbol(),MODE_MINLOT)<1)decimalPlaces=1;
   if(MarketInfo(Symbol(),MODE_MINLOT)<0.1)decimalPlaces=2;
   
   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL&&OrderSymbol()==Symbol()&&
         OrderMagicNumber()==MagicNumber)
      {
         double tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
         if(Digits==5||Digits==3)tickvalue=tickvalue*10;
         double PipProfit = (OrderProfit()/OrderLots()/tickvalue);
         string Com = OrderComment();
         //TAKE PROFIT 1
         if(PipProfit>=TakeProfit1 && StringFind(Com,"from #",0)==-1)
         {
            double LL = NormalizeDouble(OrderLots()*(TakeProfit1Percent/100),decimalPlaces);
            Print("PL= "+LL);
            OrderClose(OrderTicket(),LL,OrderClosePrice(),6,Gold);
         }
         //TAKE PROFIT 2
         if(PipProfit>=TakeProfit2 && StringFind(Com,"from #",0)>=0 && GlobalVariableCheck(Com)==false)
         {
            Print(Com);
            double PL = NormalizeDouble(OrderLots()*(TakeProfit2Percent/(100-TakeProfit1Percent)),decimalPlaces);
            int T = OrderTicket();
            if(OrderClose(OrderTicket(),PL,OrderClosePrice(),6,Gold))
            {
               if(IsTesting())string Name = "split from #"+DoubleToStr(T,0);
               if(!IsTesting())Name = "from #"+DoubleToStr(T,0);
               GlobalVariableSet(Name,9);
               /*
               if(OrderSelect(OrderTicket(),SELECT_BY_TICKET))
               {
                  string Com2 = OrderComment();
                  Print("Com2|"+Com2+"|End");
               }
               */   
            }
         }
         
         
      }
   }
   return(total);
}
void SLValue()
{
   if(HardStop>0)
   {
      BSL = HardStop;
      SSL = HardStop;
   }
   if(HardStop==0)
   {
      BSL = ((Ask-iMA(NULL, 0, MAPeriod, 0, MODE_SMMA, PRICE_CLOSE, 1))/MyPoint)+StopBelow;
      if(BSL<StopMin)BSL=StopMin;
      SSL = ((iMA(NULL, 0, MAPeriod, 0, MODE_SMMA, PRICE_CLOSE, 1)-Bid)/MyPoint)+StopAbove;
      if(SSL<StopMin)SSL=StopMin;
   }
   FTP = FinalTakeProfit;
   BLots = subLotSize(BSL);
   SLots = subLotSize(SSL);
}
void DrawValues()
{
   ObjectCreate("ezMM MagicNumber", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("ezMM MagicNumber",  DoubleToStr(MagicNumber,0), 6, "Arial", Gray);
   ObjectSet("ezMM MagicNumber", OBJPROP_CORNER, 2);
   ObjectSet("ezMM MagicNumber", OBJPROP_XDISTANCE, 5);
   ObjectSet("ezMM MagicNumber", OBJPROP_YDISTANCE, 10);
   
   ObjectCreate("ezMM BLots", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("ezMM BLots",  DoubleToStr(BLots,2), 6, "Arial", Gray);
   ObjectSet("ezMM BLots", OBJPROP_CORNER, 2);
   ObjectSet("ezMM BLots", OBJPROP_XDISTANCE, 5);
   ObjectSet("ezMM BLots", OBJPROP_YDISTANCE, 20);
   
   ObjectCreate("ezMM SLots", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("ezMM SLots",  DoubleToStr(SLots,2), 6, "Arial", Gray);
   ObjectSet("ezMM SLots", OBJPROP_CORNER, 2);
   ObjectSet("ezMM SLots", OBJPROP_XDISTANCE, 5);
   ObjectSet("ezMM SLots", OBJPROP_YDISTANCE, 30);
   
   ObjectCreate("ezMM BSL", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("ezMM BSL",  DoubleToStr(BSL,0), 6, "Arial", Gray);
   ObjectSet("ezMM BSL", OBJPROP_CORNER, 2);
   ObjectSet("ezMM BSL", OBJPROP_XDISTANCE, 5);
   ObjectSet("ezMM BSL", OBJPROP_YDISTANCE, 40);
   
   ObjectCreate("ezMM SSL", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("ezMM SSL",  DoubleToStr(SSL,0), 6, "Arial", Gray);
   ObjectSet("ezMM SSL", OBJPROP_CORNER, 2);
   ObjectSet("ezMM SSL", OBJPROP_XDISTANCE, 5);
   ObjectSet("ezMM SSL", OBJPROP_YDISTANCE, 50);
   
   ObjectCreate("ezMM FTP", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("ezMM FTP",  DoubleToStr(FTP,0), 6, "Arial", Gray);
   ObjectSet("ezMM FTP", OBJPROP_CORNER, 2);
   ObjectSet("ezMM FTP", OBJPROP_XDISTANCE, 5);
   ObjectSet("ezMM FTP", OBJPROP_YDISTANCE, 60);
   
}
double subLotSize(double SL)
{
   double lot=0;

   int    decimalPlaces=0;
   if(MarketInfo(Symbol(),MODE_MINLOT)<1)decimalPlaces=1;
   if(MarketInfo(Symbol(),MODE_MINLOT)<0.1)decimalPlaces=2;
   
   double tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   if(Digits==5||Digits==3)tickvalue=tickvalue*10;
   

   lot=NormalizeDouble(((AccountBalance()*RiskPerTrade/SL)/(tickvalue *100)),decimalPlaces);
   //if(lot<MarketInfo(Symbol(),MODE_MINLOT)) lot=MarketInfo(Symbol(),MODE_MINLOT);
   if(lot<MarketInfo(Symbol(),MODE_MINLOT)) lot=MarketInfo(Symbol(),MODE_MINLOT);
   if(lot>MarketInfo(Symbol(),MODE_MAXLOT)) lot=MarketInfo(Symbol(),MODE_MAXLOT);     
   return(lot);
}
//---------------------- BREAK EVEN FUNCTION
void subBreakEvenAfterPips(int MagicNumber,int BE)
{
    int total = OrdersTotal();
    for(int cnt=0;cnt<total;cnt++)
    {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

        if(OrderType()<=OP_SELL &&
             OrderSymbol()==Symbol() &&
             OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)
         {
            if(((Bid-OrderOpenPrice()) > (Point*BE))&&(OrderStopLoss()<OrderOpenPrice()))
                  OrderModify(
                              OrderTicket(),
                              OrderOpenPrice(),
                              NormalizeDouble(OrderOpenPrice(),Digits),
                              OrderTakeProfit(),
                              0,
                              GreenYellow);
         }
         if(OrderType()==OP_SELL)
         {
          if(((OrderOpenPrice()-Ask) > (Point*BE))&&(OrderStopLoss()>OrderOpenPrice()||OrderStopLoss()==0))
                  OrderModify(
                              OrderTicket(),
                              OrderOpenPrice(),
                              NormalizeDouble(OrderOpenPrice(),Digits),
                              OrderTakeProfit(),
                              0,
                              Red);
         }
      }
   }   
}
void subTrailingStop(int TS_MinProfit, int TrailingStop)
{
    int total = OrdersTotal();
    for(int cnt=0;cnt<total;cnt++)
    {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

        if(OrderType()<=OP_SELL &&
             OrderSymbol()==Symbol() &&
             OrderMagicNumber()==MagicNumber)
        {
           if(OrderType()==OP_BUY)   // buy position is opened   
           {

               double TS=NormalizeDouble(iMA(Symbol(), 0, TrailStopMAPeriod, 0, MODE_SMMA, PRICE_CLOSE, 1)-(TrailingStop*MyPoint),MyDigits);
               if(Bid-OrderOpenPrice()>MyPoint*TS_MinProfit &&
               OrderStopLoss()<TS)
               {
                  OrderModify(OrderTicket(),OrderOpenPrice(),TS,OrderTakeProfit(),0,Green);
               }
          
           }         
           if(OrderType()==OP_SELL)   // sell position is opened   
           {
               TS=NormalizeDouble(iMA(Symbol(), 0, TrailStopMAPeriod, 0, MODE_SMMA, PRICE_CLOSE, 1)+(TrailingStop*MyPoint),MyDigits);
                  
               if(OrderOpenPrice()-Ask>MyPoint*TS_MinProfit)
               {
                  if(OrderStopLoss()>TS || OrderStopLoss()==0)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),TS,OrderTakeProfit(),0,Red);
                     //return(0);
                  }
                }    
           }
        }
     }
}                
/*
if (TimeStopHours > 0) {
            if (Ask <= OrderOpenPrice() && OrderStopLoss() > OrderOpenPrice())
               if (OrderOpenTime() < TimeCurrent() - 3600 * TimeStopHours) CloseOrders(1, Yellow);
         }
*/

void TimeStopHours()
{
   int
      cnt, 
      total = 0;
   
   double TotalProfit = 0;
   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if((OrderType()==OP_SELL||OrderType()==OP_BUY) &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
         {
            if(OrderType()==OP_SELL)
            {
               if (TimeStopHours > 0) 
               {
                  if (Ask <= OrderOpenPrice() && OrderStopLoss() > OrderOpenPrice())
                     if (OrderOpenTime() < TimeCurrent() - 3600 * TimeStopHours) 
                        OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),6,CLR_NONE);
               }
               
            }
            if(OrderType()==OP_BUY)
            {
               if (TimeStopHours > 0) 
               {
                  if (Bid >= OrderOpenPrice() && OrderStopLoss() < OrderOpenPrice())
                     if (OrderOpenTime() < TimeCurrent() - 3600 * TimeStopHours) 
                        OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),6,CLR_NONE);
               }
            }
         }
   }
 
}         
/*
//-------------- FOR TESTING PURPOSES
int subTotalTrade()
{
   int
      cnt, 
      total = 0;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber) total++;
   }
   return(total);
}
double subPipProfitTotal()
{
   int
      cnt, 
      total = 0;
   double tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   double TotalProfit = 0;
   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if((OrderType()==OP_SELL||OrderType()==OP_BUY) &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
         {
         double PipProfit = (OrderProfit()/OrderLots()/tickvalue);
         TotalProfit = TotalProfit+PipProfit;
         }
   }
   return(TotalProfit);
} 
// OPEN ORDERS
int subOpenOrder(int type, int stoploss, int takeprofit,double Lotz)
{
   string TicketComment = "Panca SAR EA";
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
         aStopLoss   = 0,
         aTakeProfit = 0,
         bStopLoss   = 0,
         bTakeProfit = 0;

   if(stoploss!=0)
   {
      aStopLoss   = NormalizeDouble(Ask-stoploss*MyPoint,MyDigits);
      bStopLoss   = NormalizeDouble(Bid+stoploss*MyPoint,MyDigits);
   }
   
   if(takeprofit!=0)
   {
      aTakeProfit = NormalizeDouble(Ask+takeprofit*MyPoint,MyDigits);
      bTakeProfit = NormalizeDouble(Bid-takeprofit*MyPoint,MyDigits);
   }
   int NumberOfTries = 10;
   int Slippage = 6;
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lotz,NormalizeDouble(Ask,MyDigits),Slippage,aStopLoss,aTakeProfit,TicketComment,MagicNumber,0,Green);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lotz,NormalizeDouble(Bid,MyDigits),Slippage,bStopLoss,bTakeProfit,TicketComment,MagicNumber,0,Red);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }  
   return(ticket);
}
*/