//+------------------------------------------------------------------+
//|                                       ezMM - Close & Reverse.mq4 |
//|                              Copyright  2009, MethodTraders.com |
//|                                     http://www.methodtraders.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MethodTraders.com"
#property link      "http://www.methodtraders.com"
#include <WinUser32.mqh>

int MagicNumber;string    Commentary;
string OT;
int TP;
int SL;
double Lots;
int MyDigits;
double MyPoint;


//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----  
  if(Digits==5)MyDigits=4;
  else if(Digits==3)MyDigits=2;
  else MyDigits = Digits; 
  if (Point == 0.00001) MyPoint = 0.0001; //6 digits
  else if (Point == 0.001) MyPoint = 0.01; //3 digits (for Yen based pairs)
  else MyPoint = Point; //Normal
  //---- may be undefined (zero)
  Commentary = "ezMM - Close & Reverse";
  if(ObjectFind("ezMM MagicNumber")!=-1)
  {
     double  drop_price=WindowPriceOnDropped();
     MagicNumber = StrToInteger(ObjectDescription("ezMM MagicNumber"));
     int ticket = NearestTrade(drop_price);
     if(ticket>0)
     {
        int ret=MessageBox("Close & Reverse "+OT+" Order #"+ticket+" ?", "Question", MB_YESNO|MB_ICONQUESTION);
        if(ret==IDYES)
        {    
            Comment( "ezMM - Close Order  | Closing Order#"+ticket+", please wait ..." );	
            Wait();
            if(subCloseOrder(ticket)>0)
            {

               Comment( "ezMM - Reversing Order  | Closing Order#"+ticket+", please wait ..." );	
               Wait();
               int type = OP_BUY;
               if(OT == "BUY")type = OP_SELL;
               subOpenOrder(type, SL, TP, Lots);
            }             
            
        }
     }
  }
  Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+

void Wait() { while( IsTradeContextBusy() ) { Sleep(50); } }
int NearestTrade(double drop_price)
{
   int
      cnt, 
      total = 0;
   int ticket = 0;
   double Nearest = 0;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL&&OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
         {
            double Diff=MathAbs(drop_price-OrderOpenPrice());
            if(Diff == 0)Diff = 0.00000001;
            //Print("Diff= "+Diff);
            if(Nearest ==0||Diff<Nearest)
            {
               Nearest = Diff;
               ticket = OrderTicket();
         
               if(OrderType() == OP_BUY)OT = "BUY";
               if(OrderType() == OP_SELL)OT = "SELL";
               TP = (MathAbs(OrderTakeProfit()-OrderOpenPrice()))/MyPoint;
               SL = (MathAbs(OrderStopLoss()-OrderOpenPrice()))/MyPoint;
               Lots = OrderLots();
            }
         }
   }
   return(ticket);
}
int subCloseOrder(int tk)
{
   int
         cnt, 
         total       = 0,
         ticket      = 0,
         err         = 0,
         c           = 0;

   total = OrdersTotal();
   int NumberOfTries = 10;
   int Slippage = 5;
   for(cnt=total-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderSymbol() == Symbol() &&
         OrderMagicNumber()==MagicNumber &&
         OrderTicket()==tk)
      {
         switch(OrderType())
         {
            case OP_BUY      :
               for(c=0;c<NumberOfTries;c++)
               {
                  RefreshRates();
                  ticket=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,CLR_NONE);
                  err=GetLastError();
                  if(err==0)
                  { 
                     if(ticket>0) break;
                  }
                  else
                  {
                     if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        Sleep(5000);
                        continue;
                     }
                     else //normal error
                     {
                        if(ticket>0) break;
                     }  
                  }
               }   
               break;
               
            case OP_SELL     :
               for(c=0;c<NumberOfTries;c++)
               {
                  RefreshRates();
                  ticket=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,CLR_NONE);
                  err=GetLastError();
                  if(err==0)
                  { 
                     if(ticket>0) break;
                  }
                  else
                  {
                     if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        Sleep(5000);
                        continue;
                     }
                     else //normal error
                     {
                        if(ticket>0) break;
                     }  
                  }
               }   
               break;
               
         }
      }
   }      
   return(ticket);
}
int subOpenOrder(int type, int stoploss, int takeprofit,double Lotz)
{
   string TicketComment = Commentary;
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
         aStopLoss   = 0,
         aTakeProfit = 0,
         bStopLoss   = 0,
         bTakeProfit = 0;
   int NumberOfTries = 10;
   int Slippage = 5;
   if(stoploss!=0)
   {
      aStopLoss   = NormalizeDouble(Ask-stoploss*MyPoint,Digits);
      bStopLoss   = NormalizeDouble(Bid+stoploss*MyPoint,Digits);
   }
   
   if(takeprofit!=0)
   {
      aTakeProfit = NormalizeDouble(Ask+takeprofit*MyPoint,Digits);
      bTakeProfit = NormalizeDouble(Bid-takeprofit*MyPoint,Digits);
   }
   
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
      {
         RefreshRates();
         ticket=OrderSend(Symbol(),OP_BUY,Lotz,Ask,Slippage,aStopLoss,aTakeProfit,TicketComment,MagicNumber,0,CLR_NONE);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         RefreshRates();
         ticket=OrderSend(Symbol(),OP_SELL,Lotz,Bid,Slippage,bStopLoss,bTakeProfit,TicketComment,MagicNumber,0,CLR_NONE);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else if( err == 4109 )
            {
               Alert( Commentary + " - You did not allow live trading!" );
               break;
            }
            else if( err==  134 )
            {
                Alert( Commentary + " - Not enough Money!" );              
               break;
            }
         
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }  
   return(ticket);
}

